# IIS Vulnerability Scanner version 1.0 by OkIDaN
# Released: August 1, 2004. Visit my website and forum:
# http://www.freewebs.com/okidan/ && http://free.phpbb-host.org/okidan/
# Important! Read the readme.txt file for details, and distribution license.
# Usage: "perl iisvs.pl hostname". Enjoy!

# Configure these:
$port=80;    # Change it if webserver resides on another port

use IO::Socket;
use threads;
use threads::shared;

my $t : shared;
my $i : shared;
my @array : shared;

die "Usage: perl iisvs.pl hostname\n" if ($#ARGV < 0);

$def="HTTP/1.0"; # don't change it
$host=shift @ARGV || die "No hostname specified\n";
$out="$host.txt"; # change if you want to change the output filename

$dbase="data.txt"; #data file location
open (IN, "<$dbase") || die "Couldn't locate/open data file\n";
@scans=<IN>;
close (IN) || die "Problem occured while trying to close data file\n";
$num=$#scans+1;
&first_check();

$n=sprintf("%0.f", $#scans/3);
@scan1=@scans[0..$n];
@scan2=@scans[$n..$n+$n];
@scan3=@scans[$n+$n..$#scans];

threads->create(\&check, @scan1);
threads->create(\&check, @scan2);
threads->create(\&check, @scan3);

while ($t != 0){
open (OUT, ">$out");
print OUT @array;
close (OUT);
sleep 6;
}

open (OUT, ">$out") || die "Couldn't create/open output file\n";
print OUT sort @array;
close (OUT);
print "Scan ended.\n";
sub first_check(){
  $sock=new IO::Socket::INET (
    PeerAddr => $host,
    PeerPort  => $port,
    Proto      => "tcp");
  $lim="\012\015";
  die "Couldn't connect to $host:$port\n" unless ($sock);
  print $sock "HEAD / $def\n\n";#${lim}Host: http://www.$host\n\n";
  @in=<$sock>;
  close ($sock);
  print @in;
  foreach $line (@in){
    if ($line=~/^Server:\s+(.*?)\s/){
      $server=$1;
    }
  }
  if (!($server=~/IIS/i)){
    print "Server response is not IIS. Its $server. Continue?[y/n]:";
    $char=<STDIN>;
    chomp ($char);
    die "Server is not IIS. Client quits.\n" if ($char=~/^n/i);
  }
  print "Starting scan with $num checks.\n";
  print "Server: $server uses $def\n";
}

sub check() {
$t++;
@scan_now=@_;
print "Thread started\n";
while($g <= $#scan_now){
    $i++;
    $line=$scan_now[$g];
    if ($line=~/^(\w{3,5})\*{3}(.*?)\*{3}(\d{3})/){
    ($method, $url, $rc)=($1, $2, $3);
$sock=new IO::Socket::INET (
    PeerAddr => $host,
    PeerPort  => $port,
    Proto      => "tcp");
  unless ($sock){
    print "Couldnt connect on position $i of $num\n";
    $i--;
    next;
  }
  $url=~s/\/+/\//g;
  my $request="HEAD $url $def\n\n"; # if you change HEAD to $method, it will use GET almost everytime, HEAD is faster
  print $sock $request; 
  my @in=<$sock>;
  close ($sock);
  my $rc2 = (split (" ", $in[0]))[1];
  if ($rc2 != 404 && $rc2 != 400){  # you can change it to $rc2 == $rc to log and print almost only 200 rcs
    print "$rc2: $url at position $i [$num]\n";
    push @array, "$rc2: $url\n";
  }
}
$g++;}
$t--;
}
